exception EOF of int
exception MEM_LIMIT of int64
val init : unit -> unit
type lzma_stream
external new_lzma_stream : unit -> lzma_stream = "new_lzma_stream"
external lzma_stream_total_in_out : strm:lzma_stream -> int64 * int64
  = "lzma_stream_total_in_out"
type lzma_check =
    LZMA_CHECK_NONE
  | LZMA_CHECK_CRC32
  | LZMA_CHECK_CRC64
  | LZMA_CHECK_SHA256
external lzma_auto_decoder :
  strm:lzma_stream -> memlimit:int64 -> check:lzma_check -> unit
  = "caml_lzma_auto_decoder"
type lzma_preset =
    LZMA_PRESET_DEFAULT
  | LZMA_PRESET_EXTREME
  | LZMA_PRESET_TEXT
external lzma_easy_encoder :
  strm:lzma_stream ->
  level:int -> preset:lzma_preset list -> check:lzma_check -> unit
  = "caml_lzma_easy_encoder"
type lzma_options
external new_lzma_options : unit -> lzma_options = "new_lzma_options_lzma"
external lzma_preset :
  options:lzma_options -> level:int -> preset_extreme:bool -> unit
  = "caml_lzma_lzma_preset"
external lzma_alone_encoder :
  strm:lzma_stream -> options:lzma_options -> unit
  = "caml_lzma_alone_encoder"
type lzma_action = LZMA_RUN | LZMA_SYNC_FLUSH | LZMA_FULL_FLUSH | LZMA_FINISH
external lzma_code :
  strm:lzma_stream ->
  action:lzma_action ->
  next_in:string -> next_out:string -> ofs_in:int -> ofs_out:int -> int * int
  = "caml_lzma_code_bytecode" "caml_lzma_code_native"
external lzma_end : strm:lzma_stream -> unit = "caml_lzma_end"
external lzma_stream_buffer_bound : uncompressed_size:int -> int
  = "caml_lzma_stream_buffer_bound"
external lzma_easy_buffer_encode :
  level:int ->
  preset:lzma_preset list ->
  check:lzma_check -> data:string -> buf:string -> ofs:int -> int
  = "caml_lzma_easy_buffer_encode_bytecode"
  "caml_lzma_easy_buffer_encode_native"
type decoder_flags =
    LZMA_TELL_NO_CHECK
  | LZMA_TELL_UNSUPPORTED_CHECK
  | LZMA_CONCATENATED
external lzma_stream_buffer_decode :
  memlimit:int64 ->
  flags:decoder_flags list ->
  data:string -> data_ofs:int -> buf:string -> buf_ofs:int -> int * int
  = "caml_lzma_stream_buffer_decode_bytecode"
  "caml_lzma_stream_buffer_decode_native"
type stability = Alpha | Beta | Stable
type version_kind = Run_time | Compile_time
external lzma_version_number : version_kind -> int * int * int * stability
  = "caml_lzma_version_number"
external lzma_version_string : version_kind -> string
  = "caml_lzma_version_string"
